#ifndef _SEARCH_H_
#define _SEARCH_H_

#define N_STATE_VARIABLES	3
#define MAX_N_STATES_TO_CHECK	3267 //867

typedef signed char pixelListType;
typedef signed char searchLocType;

// PixelList
// Contains list of pixels to be added or deleted from an area (in order to 
// update histogram, for example).  List is in the form (x1,y1), (x2,y2), etc.
// All coordinates are relative to the center of the outline.
typedef struct {
	int n_pixels;
	pixelListType *pixels;
} PixelList;

// EllipseState
// Contains the outline's state.
typedef struct {
     int x;         // x location
     int y;         // y location
     int sz;        // size
} EllipseState;

// SearchStrategy
// Contains the search strategy, [x1, y1, s1, x2, y2, s2, ...].  All states
// are relative to the initial search location. 
// E.g., [-1 -2 -1 0 -2 -1 1 -2 1] means check the states 
// (x,y,s) = [(-1,-2,-1), (0,-2,-1), (1,-2,-1)].
typedef struct {
	int n_states_to_check;
	searchLocType ds[N_STATE_VARIABLES * MAX_N_STATES_TO_CHECK];
} SearchStrategy;

#endif  // _SEARCH_H_
